## welle.io 2.0~beta2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2)

project(Welle.Io VERSION 0.0.0 LANGUAGES C CXX)

set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_STANDARD 14)

add_definitions(-Wall)
add_definitions(-g)
add_definitions(-DDABLIN_AAC_FAAD2)

if(MINGW)
    add_definitions(-municode)
endif()

if(NOT CMAKE_BUILD_TYPE)
   set(CMAKE_BUILD_TYPE "Release")
   message(STATUS "Build type not specified: defaulting to release.")
endif(NOT CMAKE_BUILD_TYPE)
set(CMAKE_BUILD_TYPE ${CMAKE_BUILD_TYPE} CACHE STRING "")

#enable_testing()

list(INSERT CMAKE_MODULE_PATH 0 ${CMAKE_SOURCE_DIR}/cmake/Modules)

if(NOT DEFINED BUILD_WELLE_IO)
    set(BUILD_WELLE_IO ON)
endif()

if(NOT DEFINED KISS_FFT)
    set(KISS_FFT OFF)
endif()

if(NOT DEFINED PROFILING)
    set(PROFILING OFF)
endif()

if(NOT APPLE)
  if(NOT DEFINED BUILD_WELLE_CLI)
    set(BUILD_WELLE_CLI ON)
  endif()
endif()

include(GNUInstallDirs)

if(BUILD_WELLE_IO)
    set(CMAKE_AUTOMOC ON)
    set(CMAKE_AUTORCC ON)

    find_package(Qt5 COMPONENTS Widgets Quick Multimedia Charts Qml REQUIRED)
endif()

if(PROFILING)
    add_definitions(-DWITH_PROFILING)
endif()

find_package(ALSA)
if(ALSA_FOUND)
    add_definitions(-DHAVE_ALSA)
endif()

if(KISS_FFT)
    add_definitions(-DKISSFFT)
    set(fft_sources src/libs/kiss_fft/kiss_fft.c)
    set(KISS_INCLUDE_DIRS src/libs/kiss_fft)
else()
    find_package(FFTW3f REQUIRED)
    set(fft_sources "")
    set(KISS_INCLUDE_DIRS "")
endif()

if(BUILD_WELLE_CLI)
    find_package(Lame REQUIRED)
endif()

find_package(Threads REQUIRED)
find_package(Faad REQUIRED)
find_package(MPG123 REQUIRED)

if (RTLSDR)
    find_package(LibRTLSDR REQUIRED)
endif()

if (AIRSPY)
    find_package(LibAIRSPY REQUIRED)
endif()

if (SOAPYSDR)
  find_package(SoapySDR NO_MODULE REQUIRED)
  # Note: SoapySDRConfig.cmake sets C++11 standard so it needs to be reset to C++14
  set(CMAKE_CXX_STANDARD 14)
endif()

include_directories(
    src
    src/backend
    src/output
    src/various
    src/input
    src/gui
    src/libs/fec
    ${FFTW3F_INCLUDE_DIRS}
    ${KISS_INCLUDE_DIRS}
    ${FAAD_INCLUDE_DIRS}
    ${LIBRTLSDR_INCLUDE_DIRS}
    ${SoapySDR_INCLUDE_DIRS}
)

set(backend_sources
    src/backend/dab-audio.cpp
    src/backend/decoder_adapter.cpp
    src/backend/dab_decoder.cpp
    src/backend/dabplus_decoder.cpp
    src/backend/charsets.cpp
    src/backend/dab-constants.cpp
    src/backend/mot_manager.cpp
    src/backend/pad_decoder.cpp
    src/backend/eep-protection.cpp
    src/backend/fib-processor.cpp
    src/backend/fic-handler.cpp
    src/backend/msc-handler.cpp
    src/backend/freq-interleaver.cpp
    src/backend/ofdm-decoder.cpp
    src/backend/ofdm-processor.cpp
    src/backend/phasereference.cpp
    src/backend/phasetable.cpp
    src/backend/tii-decoder.cpp
    src/backend/protTables.cpp
    src/backend/radio-receiver.cpp
    src/backend/tools.cpp
    src/backend/uep-protection.cpp
    src/backend/viterbi.cpp
    src/various/Socket.cpp
    src/various/Xtan2.cpp
    src/various/channels.cpp
    src/various/fft.cpp
    src/various/profiling.cpp
    src/various/wavfile.c
    src/libs/fec/decode_rs_char.c
    src/libs/fec/encode_rs_char.c
    src/libs/fec/init_rs_char.c
)

set(welle_io_sources
    src/welle-gui/main.cpp
    src/welle-gui/audio_output.cpp
    src/welle-gui/mot_image_provider.cpp
    src/welle-gui/gui_helper.cpp
    src/welle-gui/radio_controller.cpp
    src/welle-gui/debug_output.cpp
    src/welle-gui/waterfallitem.cpp
)

set(welle_cli_sources
    src/welle-cli/welle-cli.cpp
    src/welle-cli/alsa-output.cpp
    src/welle-cli/webradiointerface.cpp
    src/welle-cli/webprogrammehandler.cpp
    src/welle-cli/tests.cpp
)

set(input_sources
    src/input/input_factory.cpp
    src/input/null_device.cpp
    src/input/raw_file.cpp
    src/input/rtl_tcp.cpp
)

if(LIBRTLSDR_FOUND)
    add_definitions (-DHAVE_RTLSDR)
    set(input_sources  ${input_sources} src/input/rtl_sdr.cpp)
endif()

if(LIBAIRSPY_FOUND)
    add_definitions (-DHAVE_AIRSPY)
    set(input_sources  ${input_sources} src/input/airspy_sdr.cpp)
endif()

if(SoapySDR_FOUND)
    add_definitions (-DHAVE_SOAPYSDR)
    set(input_sources  ${input_sources} src/input/soapy_sdr.cpp)
endif()

if(NOT GIT_COMMIT_HASH)
  execute_process(
    COMMAND git rev-parse --short HEAD
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    OUTPUT_VARIABLE GIT_COMMIT_HASH
    OUTPUT_STRIP_TRAILING_WHITESPACE
  )
endif()

if(GIT_COMMIT_HASH)
  add_definitions("-DGITHASH=\"${GIT_COMMIT_HASH}\"")
endif()

if(NOT GIT_DESCRIBE)
  execute_process(
    COMMAND git describe --tags --long
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    OUTPUT_VARIABLE GIT_DESCRIBE
    OUTPUT_STRIP_TRAILING_WHITESPACE
  )
endif()

if(GIT_DESCRIBE)
  add_definitions("-DGITDESCRIBE=\"${GIT_DESCRIBE}\"")
endif()

if(BUILD_WELLE_IO)
    set(executableName welle-io)
    add_executable (${executableName} ${welle_io_sources} ${backend_sources} ${input_sources} ${fft_sources} ${EXTRA_MOCS} src/welle-gui/resources.qrc)

    target_link_libraries (${executableName}
      ${LIBRTLSDR_LIBRARIES}
      ${LIBAIRSPY_LIBRARIES}
      ${FFTW3F_LIBRARIES}
      ${FAAD_LIBRARIES}
      ${SoapySDR_LIBRARIES}
      ${MPG123_LIBRARIES}
      Threads::Threads
      Qt5::Core Qt5::Widgets Qt5::Multimedia Qt5::Charts Qt5::Qml Qt5::Quick
    )

    INSTALL (TARGETS ${executableName} RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()

if(BUILD_WELLE_CLI)
    set(cliExecutableName welle-cli)
    add_executable (${cliExecutableName} ${welle_cli_sources} ${backend_sources} ${input_sources} ${fft_sources})

    if(CMAKE_BUILD_TYPE MATCHES Debug)
      SET_TARGET_PROPERTIES(${cliExecutableName} PROPERTIES COMPILE_FLAGS "-O2 -fno-omit-frame-pointer -fsanitize=address")
      SET_TARGET_PROPERTIES(${cliExecutableName} PROPERTIES LINK_FLAGS "-fno-omit-frame-pointer -fsanitize=address")
    endif(CMAKE_BUILD_TYPE MATCHES Debug)

    target_link_libraries (${cliExecutableName}
      ${LIBRTLSDR_LIBRARIES}
      ${LIBAIRSPY_LIBRARIES}
      ${FFTW3F_LIBRARIES}
      ${FAAD_LIBRARIES}
      ${ALSA_LIBRARIES}
      ${LAME_LIBRARIES}
      ${SoapySDR_LIBRARIES}
      ${MPG123_LIBRARIES}
      Threads::Threads
    )

    INSTALL (TARGETS ${cliExecutableName} RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

    add_custom_command(
            TARGET ${cliExecutableName} POST_BUILD
            COMMAND ${CMAKE_COMMAND} -E copy
                    ${CMAKE_SOURCE_DIR}/src/welle-cli/index.html
                    ${CMAKE_CURRENT_BINARY_DIR}/index.html)
    add_custom_command(
            TARGET ${cliExecutableName} POST_BUILD
            COMMAND ${CMAKE_COMMAND} -E copy
                    ${CMAKE_SOURCE_DIR}/src/welle-cli/index.js
                    ${CMAKE_CURRENT_BINARY_DIR}/index.js)
endif()

INSTALL (FILES ${PROJECT_SOURCE_DIR}/welle-io.desktop DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/applications)

INSTALL (FILES ${PROJECT_SOURCE_DIR}/src/welle-gui/icon/16x16/welle-io.png DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/16x16/apps)
INSTALL (FILES ${PROJECT_SOURCE_DIR}/src/welle-gui/icon/24x24/welle-io.png DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/24x24/apps)
INSTALL (FILES ${PROJECT_SOURCE_DIR}/src/welle-gui/icon/32x32/welle-io.png DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/32x32/apps)
INSTALL (FILES ${PROJECT_SOURCE_DIR}/src/welle-gui/icon/48x48/welle-io.png DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/48x48/apps)
INSTALL (FILES ${PROJECT_SOURCE_DIR}/src/welle-gui/icon/128x128/welle-io.png DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/128x128/apps)
INSTALL (FILES ${PROJECT_SOURCE_DIR}/src/welle-gui/icon/256x256/welle-io.png DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/256x256/apps)

INSTALL (
  FILES
    ${PROJECT_SOURCE_DIR}/src/welle-cli/index.html
    ${PROJECT_SOURCE_DIR}/src/welle-cli/index.js
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/welle-io/html/
)

configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY)

add_custom_target(uninstall
    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)

## welle.io 2.0~beta1

=== debian/changelog ===
welle.io (2.0~beta1-1) unstable; urgency=medium

  * Initial release. (Closes: #918556)

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Fri, 04 Jan 2019 14:20:37 +0100

=== debian/control ===
Source: welle.io
Section: hamradio
Priority: optional
Maintainer: Gürkan Myczko <gurkan@phys.ethz.ch>
Build-Depends: debhelper (>= 11), libqt5charts5-dev, cmake, qtbase5-dev, qttools5-dev-tools, libsoapysdr-dev, librtlsdr-dev, qtquickcontrols2-5-dev, libqt5quick5, libfaad-dev, libmpg123-dev, libfftw3-dev, libmp3lame-dev, qtdeclarative5-dev, qtmultimedia5-dev
Standards-Version: 4.3.0
Homepage: https://www.welle.io/

Package: welle.io
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libqt5quick5, libqt5multimedia5-plugins, qml-module-qt-labs-settings, qml-module-qtquick-window2, qml-module-qtquick2, qml-module-qtquick-layouts, qml-module-qtquick-dialogs, qml-module-qtquick-controls2, qml-module-qtquick-controls, qml-module-qtquick-templates2, qml-module-qtquick-privatewidgets, qml-module-qtquick-localstorage
Description: DAB/DAB+ Software Radio
 This is an open source DAB and DAB+ software defined radio (SDR) with support
 for rtl-sdr (RTL2832U) and airspy. It supports high DPI and touch displays and
 it runs even on cheap computers like Raspberry Pi 2/3 and 100€ China Windows
 10 tablets.

## welle.io 2.0~beta2

=== debian/changelog ===
welle.io (2.0~beta2-2) unstable; urgency=medium

  * d/control: add libpulse-dev, libasound2-dev, libairspy-dev.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Wed, 14 Aug 2019 15:46:20 +0200

welle.io (2.0~beta2-1) unstable; urgency=medium

  * New upstream version.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Fri, 31 May 2019 14:21:33 +0200

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: hamradio
 Priority: optional
 Maintainer: Gürkan Myczko <gurkan@phys.ethz.ch>
-Build-Depends: debhelper (>= 11), libqt5charts5-dev, cmake, qtbase5-dev, qttools5-dev-tools, libsoapysdr-dev, librtlsdr-dev, qtquickcontrols2-5-dev, libqt5quick5, libfaad-dev, libmpg123-dev, libfftw3-dev, libmp3lame-dev, qtdeclarative5-dev, qtmultimedia5-dev
+Build-Depends: debhelper (>= 11), libqt5charts5-dev, cmake, qtbase5-dev, qttools5-dev-tools, libsoapysdr-dev, librtlsdr-dev, qtquickcontrols2-5-dev, libqt5quick5, libfaad-dev, libmpg123-dev, libfftw3-dev, libmp3lame-dev, qtdeclarative5-dev, qtmultimedia5-dev, libpulse-dev, libasound2-dev, libairspy-dev
 Standards-Version: 4.3.0
 Homepage: https://www.welle.io/

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export QTDIR=/usr/share/qt5
export QT_SELECT=qt5

# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DRTLSDR=1 -DSOAPYSDR=1 -DGITDESCRIBE=2019

override_dh_auto_install:
	@echo skip install target

=== debian/watch ===
version=4
# GitHub hosted projects
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%<project>-$1.tar.gz%" \
   https://github.com/AlbrechtL/welle.io/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## welle.io 2.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,22 @@
 cmake_minimum_required(VERSION 3.2)
 
 project(Welle.Io VERSION 0.0.0 LANGUAGES C CXX)
+
+if(NOT WELLE-IO_VERSION)
+  set(WELLE-IO_VERSION ${PROJECT_VERSION})
+endif()
 
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 set(CMAKE_CXX_STANDARD 14)
+
+option(BUILD_WELLE_IO    "Build Welle.io"                        ON  )
+option(BUILD_WELLE_CLI   "Build welle-cli"                       ON  )
+option(WITH_APP_BUNDLE   "Enable Application Bundle for macOS"   ON  )
+option(KISS_FFT          "KISS FFT instead of FFTW"              OFF )
+option(PROFILING         "Enable profiling (see README.md)"      OFF )
+option(AIRSPY            "Compile with Airspy support"           OFF )
+option(RTLSDR            "Compile with RTL-SDR support"          OFF )
+option(SOAPYSDR          "Compile with SoapySDR support"         OFF )
 
 add_definitions(-Wall)
 add_definitions(-g)
@@ -23,31 +36,23 @@
 
 list(INSERT CMAKE_MODULE_PATH 0 ${CMAKE_SOURCE_DIR}/cmake/Modules)
 
-if(NOT DEFINED BUILD_WELLE_IO)
-    set(BUILD_WELLE_IO ON)
-endif()
-
-if(NOT DEFINED KISS_FFT)
-    set(KISS_FFT OFF)
-endif()
-
-if(NOT DEFINED PROFILING)
-    set(PROFILING OFF)
-endif()
-
-if(NOT APPLE)
-  if(NOT DEFINED BUILD_WELLE_CLI)
-    set(BUILD_WELLE_CLI ON)
-  endif()
-endif()
-
-include(GNUInstallDirs)
+if(APPLE AND WITH_APP_BUNDLE)
+    if(NOT DEFINED BUNDLE_INSTALL_DIR)
+        set(BUNDLE_INSTALL_DIR "/Applications")
+    endif()
+
+    set(GUI_INSTALL_DIR "${BUNDLE_INSTALL_DIR}")
+else()
+    include(GNUInstallDirs)
+
+    set(GUI_INSTALL_DIR "${CMAKE_INSTALL_BINDIR}")
+endif()
 
 if(BUILD_WELLE_IO)
     set(CMAKE_AUTOMOC ON)
     set(CMAKE_AUTORCC ON)
 
-    find_package(Qt5 COMPONENTS Widgets Quick Multimedia Charts Qml REQUIRED)
+    find_package(Qt5 COMPONENTS Widgets Quick QuickControls2 Multimedia Charts Qml REQUIRED)
 endif()
 
 if(PROFILING)
@@ -219,10 +224,39 @@
       ${SoapySDR_LIBRARIES}
       ${MPG123_LIBRARIES}
       Threads::Threads
-      Qt5::Core Qt5::Widgets Qt5::Multimedia Qt5::Charts Qt5::Qml Qt5::Quick
+      Qt5::Core Qt5::Widgets Qt5::Multimedia Qt5::Charts Qt5::Qml Qt5::Quick Qt5::QuickControls2
     )
 
-    INSTALL (TARGETS ${executableName} RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
+    if(APPLE AND WITH_APP_BUNDLE)
+        set(macOsIcon ${CMAKE_CURRENT_SOURCE_DIR}/src/welle-gui/icons/icon.icns)
+        set_source_files_properties(${macOsIcon} PROPERTIES MACOSX_PACKAGE_LOCATION "Resources")
+        target_sources(${executableName} PRIVATE ${macOsIcon})
+
+        set(SHORT_VERSION "${WELLE-IO_VERSION}")
+        set(EXECUTABLE "${executableName}")
+        set(TYPEINFO "io.welle.welle")
+        set(PRODUCT_BUNDLE_IDENTIFIER "io.welle.welle")
+
+        set_target_properties("${executableName}" PROPERTIES
+            MACOSX_BUNDLE TRUE
+            MACOSX_BUNDLE_INFO_PLIST ${CMAKE_CURRENT_SOURCE_DIR}/welle-io.plist
+        )
+
+        INSTALL (TARGETS ${executableName} BUNDLE DESTINATION ${GUI_INSTALL_DIR})
+    else()
+        INSTALL (TARGETS ${executableName} RUNTIME DESTINATION ${GUI_INSTALL_DIR})
+
+        if(UNIX AND NOT APPLE)
+            INSTALL (FILES ${PROJECT_SOURCE_DIR}/welle-io.desktop DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/applications)
+
+            INSTALL (FILES ${PROJECT_SOURCE_DIR}/src/welle-gui/icons/16x16/welle-io.png DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/16x16/apps)
+            INSTALL (FILES ${PROJECT_SOURCE_DIR}/src/welle-gui/icons/24x24/welle-io.png DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/24x24/apps)
+            INSTALL (FILES ${PROJECT_SOURCE_DIR}/src/welle-gui/icons/32x32/welle-io.png DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/32x32/apps)
+            INSTALL (FILES ${PROJECT_SOURCE_DIR}/src/welle-gui/icons/48x48/welle-io.png DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/48x48/apps)
+            INSTALL (FILES ${PROJECT_SOURCE_DIR}/src/welle-gui/icons/128x128/welle-io.png DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/128x128/apps)
+            INSTALL (FILES ${PROJECT_SOURCE_DIR}/src/welle-gui/icons/256x256/welle-io.png DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/256x256/apps)
+        endif()
+    endif()
 endif()
 
 if(BUILD_WELLE_CLI)
@@ -246,8 +280,6 @@
       Threads::Threads
     )
 
-    INSTALL (TARGETS ${cliExecutableName} RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
-
     add_custom_command(
             TARGET ${cliExecutableName} POST_BUILD
             COMMAND ${CMAKE_COMMAND} -E copy
@@ -258,23 +290,25 @@
             COMMAND ${CMAKE_COMMAND} -E copy
                     ${CMAKE_SOURCE_DIR}/src/welle-cli/index.js
                     ${CMAKE_CURRENT_BINARY_DIR}/index.js)
-endif()
-
-INSTALL (FILES ${PROJECT_SOURCE_DIR}/welle-io.desktop DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/applications)
-
-INSTALL (FILES ${PROJECT_SOURCE_DIR}/src/welle-gui/icon/16x16/welle-io.png DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/16x16/apps)
-INSTALL (FILES ${PROJECT_SOURCE_DIR}/src/welle-gui/icon/24x24/welle-io.png DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/24x24/apps)
-INSTALL (FILES ${PROJECT_SOURCE_DIR}/src/welle-gui/icon/32x32/welle-io.png DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/32x32/apps)
-INSTALL (FILES ${PROJECT_SOURCE_DIR}/src/welle-gui/icon/48x48/welle-io.png DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/48x48/apps)
-INSTALL (FILES ${PROJECT_SOURCE_DIR}/src/welle-gui/icon/128x128/welle-io.png DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/128x128/apps)
-INSTALL (FILES ${PROJECT_SOURCE_DIR}/src/welle-gui/icon/256x256/welle-io.png DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/256x256/apps)
-
-INSTALL (
-  FILES
-    ${PROJECT_SOURCE_DIR}/src/welle-cli/index.html
-    ${PROJECT_SOURCE_DIR}/src/welle-cli/index.js
-  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/welle-io/html/
-)
+
+    if(APPLE AND WITH_APP_BUNDLE)
+        INSTALL (TARGETS ${cliExecutableName} RUNTIME DESTINATION ${GUI_INSTALL_DIR}/${executableName}.app/Contents/MacOS)
+        INSTALL (
+            FILES
+                ${PROJECT_SOURCE_DIR}/src/welle-cli/index.html
+                ${PROJECT_SOURCE_DIR}/src/welle-cli/index.js
+            DESTINATION ${GUI_INSTALL_DIR}/${executableName}.app/Contents/Resources/welle-cli
+        )
+    elseif(UNIX)
+        INSTALL (TARGETS ${cliExecutableName} RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
+        INSTALL (
+            FILES
+                ${PROJECT_SOURCE_DIR}/src/welle-cli/index.html
+                ${PROJECT_SOURCE_DIR}/src/welle-cli/index.js
+            DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/welle-io/html/
+        )
+    endif()
+endif()
 
 configure_file(
     "${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"

=== debian/changelog ===
welle.io (2.1-2build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 24 Mar 2020 15:19:44 +0100

welle.io (2.1-2) unstable; urgency=medium

  * d/rules: include pkg-info.mk for $DEB_VERSION_UPSTREAM.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Tue, 10 Dec 2019 07:26:05 +0100

welle.io (2.1-1) unstable; urgency=medium

  * New upstream version.
  * Many thanks to Fab Stz for improvements on the packaging.
  * d/control: Add qml-module-qtgraphicaleffects to Build-Depends.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Thu, 05 Dec 2019 09:06:13 +0100

welle.io (2.0-2) unstable; urgency=medium

  * Add Vcs fields.
  * Bump standards version to 4.4.1.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Tue, 29 Oct 2019 10:17:55 +0100

welle.io (2.0-1) unstable; urgency=medium

  * New upstream version.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Mon, 21 Oct 2019 09:09:00 +0200

welle.io (2.0~beta3-1) unstable; urgency=medium

  * New upstream version.
  * Add to Debian Hamradio Maintainers Team.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Tue, 10 Sep 2019 15:24:04 +0200

welle.io (2.0~beta2-3) unstable; urgency=medium

  * d/control: add bin/dep qml-module-qtcharts. (Closes: #939484)
  * Bump standards version to 4.4.0.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Thu, 05 Sep 2019 16:16:58 +0200

=== debian/control ===
Source: welle.io
Section: hamradio
Priority: optional
Maintainer: Debian Hamradio Maintainers <debian-hams@lists.debian.org>
Uploaders: Gürkan Myczko <gurkan@phys.ethz.ch>
Build-Depends: debhelper (>= 11), libqt5charts5-dev, cmake, qtbase5-dev, qttools5-dev-tools, libsoapysdr-dev, librtlsdr-dev, qtquickcontrols2-5-dev, libqt5quick5, libfaad-dev, libmpg123-dev, libfftw3-dev, libmp3lame-dev, qtdeclarative5-dev, qtmultimedia5-dev, libpulse-dev, libasound2-dev, libairspy-dev
Standards-Version: 4.4.1
Vcs-Git: https://salsa.debian.org/debian-hamradio-team/welle.io.git
Vcs-Browser: https://salsa.debian.org/debian-hamradio-team/welle.io
Homepage: https://www.welle.io/

Package: welle.io
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libqt5quick5, libqt5multimedia5-plugins, qml-module-qt-labs-settings, qml-module-qtquick-window2, qml-module-qtquick2, qml-module-qtquick-layouts, qml-module-qtquick-dialogs, qml-module-qtquick-controls2, qml-module-qtquick-controls, qml-module-qtquick-templates2, qml-module-qtquick-privatewidgets, qml-module-qtquick-localstorage, qml-module-qtcharts, qml-module-qtgraphicaleffects
Description: DAB/DAB+ Software Radio
 This is an open source DAB and DAB+ software defined radio (SDR) with support
 for rtl-sdr (RTL2832U) and airspy. It supports high DPI and touch displays and
 it runs even on cheap computers like Raspberry Pi 2/3 and 100€ China Windows
 10 tablets.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

include /usr/share/dpkg/pkg-info.mk

export QTDIR=/usr/share/qt5
export QT_SELECT=qt5

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DRTLSDR=1 -DSOAPYSDR=1 -DAIRSPY=1 -DGIT_COMMIT_HASH=8fc5739 -DGIT_DESCRIBE=${DEB_VERSION_UPSTREAM}

#override_dh_auto_install:
#	@echo skip install target

=== debian/watch ===
version=4
# GitHub hosted projects
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%$1.tar.gz%" \
   https://github.com/AlbrechtL/welle.io/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## welle.io 2.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -160,6 +160,7 @@
     src/welle-cli/welle-cli.cpp
     src/welle-cli/alsa-output.cpp
     src/welle-cli/webradiointerface.cpp
+    src/welle-cli/jsonconvert.cpp
     src/welle-cli/webprogrammehandler.cpp
     src/welle-cli/tests.cpp
 )

=== debian/changelog ===
welle.io (2.2-1build1) jammy; urgency=medium

  * No-change rebuild against libsoapysdr0.8

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 08 Nov 2021 19:13:07 +0000

welle.io (2.2-1) unstable; urgency=medium

  * New upstream version.
  * Bump standards version to 4.5.0.
  * Bump debhelper version to 13, drop d/compat.
  * d/control: added Rules-Requires-Root.
  * d/copyright:
    - update copyright years.
    - fix order of globbing-patterns.
    - added Upstream-Contact.
  * d/upstream/metadata: added.
  * d/source.lintian-overrieds moved to d/s/lintian-overrides.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Wed, 26 Aug 2020 07:39:18 +0200

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,14 @@
 Source: welle.io
 Section: hamradio
 Priority: optional
-Maintainer: Debian Hamradio Maintainers <debian-hams@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Hamradio Maintainers <debian-hams@lists.debian.org>
 Uploaders: Gürkan Myczko <gurkan@phys.ethz.ch>
-Build-Depends: debhelper (>= 11), libqt5charts5-dev, cmake, qtbase5-dev, qttools5-dev-tools, libsoapysdr-dev, librtlsdr-dev, qtquickcontrols2-5-dev, libqt5quick5, libfaad-dev, libmpg123-dev, libfftw3-dev, libmp3lame-dev, qtdeclarative5-dev, qtmultimedia5-dev, libpulse-dev, libasound2-dev, libairspy-dev
-Standards-Version: 4.4.1
+Build-Depends: debhelper-compat (= 13), libqt5charts5-dev, cmake, qtbase5-dev, qttools5-dev-tools, libsoapysdr-dev, librtlsdr-dev, qtquickcontrols2-5-dev, libqt5quick5, libfaad-dev, libmpg123-dev, libfftw3-dev, libmp3lame-dev, qtdeclarative5-dev, qtmultimedia5-dev, libpulse-dev, libasound2-dev, libairspy-dev
+Standards-Version: 4.5.0
 Vcs-Git: https://salsa.debian.org/debian-hamradio-team/welle.io.git
 Vcs-Browser: https://salsa.debian.org/debian-hamradio-team/welle.io
+Rules-Requires-Root: no
 Homepage: https://www.welle.io/
 
 Package: welle.io

=== debian/rules ===
--- 
+++ 
@@ -20,6 +20,3 @@
 
 override_dh_auto_configure:
 	dh_auto_configure -- -DRTLSDR=1 -DSOAPYSDR=1 -DAIRSPY=1 -DGIT_COMMIT_HASH=8fc5739 -DGIT_DESCRIBE=${DEB_VERSION_UPSTREAM}
-
-#override_dh_auto_install:
-#	@echo skip install target

## welle.io 2.3

=== debian/changelog ===
welle.io (2.3-1~mx19+2) mx; urgency=medium

  * Initial packaging of upstream release for MX-19.
  * d/control: add libusb-1.0-0-dev, mesa-common-dev, libglu1-mesa-dev to BDs
   since they referenced by the developer.

 -- SwampRabbit <swamprabbit@mxlinux.org>  Wed, 26 May 2021 15:00:34 -0400

welle.io (2.2-1~mx19+1) mx; urgency=medium

  * Initial packaging of upstream release for MX 19.

 -- SwampRabbit <wamprabbit@mxlinux.org>  Tue, 01 Sep 2020 13:05:59 -0400

=== debian/control ===
Source: welle.io
Section: hamradio
Priority: optional
Maintainer: SwampRabbit <swamprabbit@mxlinux.org>
XSBC-Original-Maintainer: Debian Hamradio Maintainers <debian-hams@lists.debian.org>
Uploaders: Gürkan Myczko <gurkan@phys.ethz.ch>
Build-Depends: debhelper (>= 11), libqt5charts5-dev, cmake, qtbase5-dev, qttools5-dev-tools, libsoapysdr-dev, librtlsdr-dev, qtquickcontrols2-5-dev, libqt5quick5, libfaad-dev, libmpg123-dev, libfftw3-dev, libmp3lame-dev, qtdeclarative5-dev, qtmultimedia5-dev, libpulse-dev, libasound2-dev, libairspy-dev, libusb-1.0-0-dev, mesa-common-dev, libglu1-mesa-dev
Standards-Version: 4.4.1
Vcs-Git: https://salsa.debian.org/debian-hamradio-team/welle.io.git
Vcs-Browser: https://salsa.debian.org/debian-hamradio-team/welle.io
Homepage: https://www.welle.io/

Package: welle.io
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libqt5quick5, libqt5multimedia5-plugins, qml-module-qt-labs-settings, qml-module-qtquick-window2, qml-module-qtquick2, qml-module-qtquick-layouts, qml-module-qtquick-dialogs, qml-module-qtquick-controls2, qml-module-qtquick-controls, qml-module-qtquick-templates2, qml-module-qtquick-privatewidgets, qml-module-qtquick-localstorage, qml-module-qtcharts, qml-module-qtgraphicaleffects, libfftw3-single3
Description: DAB/DAB+ Software Radio
 This is an open source DAB and DAB+ software defined radio (SDR) with support
 for rtl-sdr (RTL2832U) and airspy. It supports high DPI and touch displays and
 it runs even on cheap computers like Raspberry Pi 2/3 and 100€ China Windows
 10 tablets.

=== debian/rules ===
--- 
+++ 
@@ -20,3 +20,9 @@
 
 override_dh_auto_configure:
 	dh_auto_configure -- -DRTLSDR=1 -DSOAPYSDR=1 -DAIRSPY=1 -DGIT_COMMIT_HASH=8fc5739 -DGIT_DESCRIBE=${DEB_VERSION_UPSTREAM}
+
+#override_dh_auto_install:
+#	@echo skip install target
+
+override_dh_strip:
+	dh_strip --no-automatic-dbgsym

## welle.io 2.4+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -52,7 +52,7 @@
     set(CMAKE_AUTOMOC ON)
     set(CMAKE_AUTORCC ON)
 
-    find_package(Qt5 COMPONENTS Widgets Quick QuickControls2 Multimedia Charts Qml REQUIRED)
+    find_package(Qt5 COMPONENTS Widgets Quick QuickControls2 Multimedia Charts Qml DBus REQUIRED)
 endif()
 
 if(PROFILING)
@@ -152,6 +152,9 @@
     src/welle-gui/mot_image_provider.cpp
     src/welle-gui/gui_helper.cpp
     src/welle-gui/radio_controller.cpp
+    src/welle-gui/mpris/mpris.cpp
+    src/welle-gui/mpris/mpris_mp2.cpp
+    src/welle-gui/mpris/mpris_mp2_player.cpp
     src/welle-gui/debug_output.cpp
     src/welle-gui/waterfallitem.cpp
 )
@@ -212,6 +215,9 @@
 if(GIT_DESCRIBE)
   add_definitions("-DGITDESCRIBE=\"${GIT_DESCRIBE}\"")
 endif()
+
+STRING(TIMESTAMP BUILD_DATE "%s" UTC)
+add_definitions("-DBUILD_DATE=\"${BUILD_DATE}\"")
 
 if(BUILD_WELLE_IO)
     set(executableName welle-io)
@@ -225,7 +231,7 @@
       ${SoapySDR_LIBRARIES}
       ${MPG123_LIBRARIES}
       Threads::Threads
-      Qt5::Core Qt5::Widgets Qt5::Multimedia Qt5::Charts Qt5::Qml Qt5::Quick Qt5::QuickControls2
+      Qt5::Core Qt5::Widgets Qt5::Multimedia Qt5::Charts Qt5::Qml Qt5::Quick Qt5::QuickControls2 Qt5::DBus
     )
 
     if(APPLE AND WITH_APP_BUNDLE)
@@ -246,6 +252,7 @@
         INSTALL (TARGETS ${executableName} BUNDLE DESTINATION ${GUI_INSTALL_DIR})
     else()
         INSTALL (TARGETS ${executableName} RUNTIME DESTINATION ${GUI_INSTALL_DIR})
+        INSTALL (FILES src/welle-gui/doc/man/welle-io.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1/)
 
         if(UNIX AND NOT APPLE)
             INSTALL (FILES ${PROJECT_SOURCE_DIR}/welle-io.desktop DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/applications)
@@ -302,6 +309,7 @@
         )
     elseif(UNIX)
         INSTALL (TARGETS ${cliExecutableName} RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
+        INSTALL (FILES src/welle-cli/doc/man/welle-cli.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1/)
         INSTALL (
             FILES
                 ${PROJECT_SOURCE_DIR}/src/welle-cli/index.html

=== debian/changelog ===
welle.io (2.4+ds-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS with CMake 4. (Closes: #1113629)

 -- Adrian Bunk <bunk@debian.org>  Mon, 20 Oct 2025 11:09:21 +0300

welle.io (2.4+ds-4) unstable; urgency=medium

  * Bump standards version to 4.7.0.

 -- Alex Myczko <tar@debian.org>  Sun, 14 Jul 2024 20:21:44 +0000

welle.io (2.4+ds-3) unstable; urgency=medium

  * Team upload.
  * No longer define MPG123_NO_LARGENAME to address FTBFS on arm{eh,hf}
    (Closes: #1068512)

 -- tony mancill <tmancill@debian.org>  Sun, 07 Apr 2024 20:58:07 -0700

welle.io (2.4+ds-2) unstable; urgency=medium

  * remove manpages, they are shipped by upstream
  * d/rules: remove -DGIT_COMMIT_HASH=8fc5739
  * add patch 'append-theme-path.patch'
  * fix lintian errors & warning
  * d/watch: mangle version name since we use +ds suffix
  * update DEP-3 header of patch
  * apply wrap-and-sort to debian/*
  * bump Standards-Version: 4.6.1 (no changes required)

 -- Fab Stz <fabstz-it@yahoo.fr>  Mon, 15 Aug 2022 15:25:24 +0200

welle.io (2.4+ds-1) experimental; urgency=medium

  * New upstream release.
  * Bump standards version to 4.6.0.
  * Update maintainer address.
  * d/copyright: bump years.

 -- Gürkan Myczko <tar@debian.org>  Mon, 14 Feb 2022 23:11:20 +0100

welle.io (2.3-1) experimental; urgency=medium

  * New upstream version.
  * d/copyright: update path for json file.
  * Bump standards version to 4.5.1.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Tue, 25 May 2021 20:22:52 +0200

=== debian/control ===
Source: welle.io
Section: hamradio
Priority: optional
Maintainer: Debian Hamradio Maintainers <debian-hams@lists.debian.org>
Uploaders: Alex Myczko <tar@debian.org>, Fab Stz <fabstz-it@yahoo.fr>
Build-Depends: cmake,
               debhelper-compat (= 13),
               libairspy-dev,
               libasound2-dev,
               libfaad-dev,
               libfftw3-dev,
               libmp3lame-dev,
               libmpg123-dev,
               libpulse-dev,
               libqt5charts5-dev,
               libqt5quick5,
               librtlsdr-dev,
               libsoapysdr-dev,
               qtbase5-dev,
               qtdeclarative5-dev,
               qtmultimedia5-dev,
               qtquickcontrols2-5-dev,
               qttools5-dev-tools
Standards-Version: 4.7.0
Vcs-Git: https://salsa.debian.org/debian-hamradio-team/welle.io.git
Vcs-Browser: https://salsa.debian.org/debian-hamradio-team/welle.io
Rules-Requires-Root: no
Homepage: https://www.welle.io/

Package: welle.io
Architecture: any
Depends: libqt5multimedia5-plugins,
         libqt5quick5,
         qml-module-qt-labs-settings,
         qml-module-qtcharts,
         qml-module-qtgraphicaleffects,
         qml-module-qtquick-controls,
         qml-module-qtquick-controls2,
         qml-module-qtquick-dialogs,
         qml-module-qtquick-layouts,
         qml-module-qtquick-localstorage,
         qml-module-qtquick-privatewidgets,
         qml-module-qtquick-templates2,
         qml-module-qtquick-window2,
         qml-module-qtquick2,
         ${misc:Depends},
         ${shlibs:Depends}
Description: DAB/DAB+ Software Radio
 This is an open source DAB and DAB+ software defined radio (SDR) with support
 for rtl-sdr (RTL2832U) and airspy. It supports high DPI and touch displays and
 it runs even on cheap computers like Raspberry Pi 2/3 and 100€ China Windows
 10 tablets.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

include /usr/share/dpkg/pkg-info.mk

export QTDIR=/usr/share/qt5
export QT_SELECT=qt5

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DRTLSDR=1 -DSOAPYSDR=1 -DAIRSPY=1 -DGIT_DESCRIBE=${DEB_VERSION_UPSTREAM}

## welle.io 2.7+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2)

project(Welle.Io LANGUAGES C CXX)

file(READ "src/welle-gui/_current_version" VERSION_FILE)
string(STRIP ${VERSION_FILE} CURRENT_VERSION)
set(PROJECT_VERSION ${CURRENT_VERSION})

message ("Building project '${PROJECT_NAME}' version '${PROJECT_VERSION}'...")

if(NOT WELLE-IO_VERSION)
  set(WELLE-IO_VERSION ${PROJECT_VERSION})
endif()

set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_STANDARD 14)

option(BUILD_WELLE_IO    "Build Welle.io"                        ON  )
option(BUILD_WELLE_CLI   "Build welle-cli"                       ON  )
option(WITH_APP_BUNDLE   "Enable Application Bundle for macOS"   ON  )
option(KISS_FFT          "KISS FFT instead of FFTW"              OFF )
option(PROFILING         "Enable profiling (see README.md)"      OFF )
option(AIRSPY            "Compile with Airspy support"           OFF )
option(RTLSDR            "Compile with RTL-SDR support"          OFF )
option(SOAPYSDR          "Compile with SoapySDR support"         OFF )
option(FLAC              "Compile with flac support for streaming" OFF )

add_definitions(-Wall)
add_definitions(-g)
add_definitions(-DDABLIN_AAC_FAAD2)

if(MINGW)
    add_definitions(-municode)
endif()

if(NOT CMAKE_BUILD_TYPE)
   set(CMAKE_BUILD_TYPE "Release")
   message(STATUS "Build type not specified: defaulting to release.")
endif(NOT CMAKE_BUILD_TYPE)
set(CMAKE_BUILD_TYPE ${CMAKE_BUILD_TYPE} CACHE STRING "")

#enable_testing()

list(INSERT CMAKE_MODULE_PATH 0 ${CMAKE_SOURCE_DIR}/cmake/Modules)

if(APPLE AND WITH_APP_BUNDLE)
    if(NOT DEFINED BUNDLE_INSTALL_DIR)
        set(BUNDLE_INSTALL_DIR "/Applications")
    endif()

    set(GUI_INSTALL_DIR "${BUNDLE_INSTALL_DIR}")
else()
    include(GNUInstallDirs)

    set(GUI_INSTALL_DIR "${CMAKE_INSTALL_BINDIR}")
endif()

if(BUILD_WELLE_IO)
    find_package(Qt6 COMPONENTS Widgets Quick QuickControls2 Multimedia Charts Qml REQUIRED)
    set(CMAKE_AUTOMOC ON)
    if(ANDROID AND Qt6Core_VERSION VERSION_LESS 6.8.0)
        # Woraround for QTBUG-106466
        set(CMAKE_AUTORCC ON)
    endif()
endif()

if(PROFILING)
    add_definitions(-DWITH_PROFILING)
endif()

find_package(ALSA)
if(ALSA_FOUND)
    add_definitions(-DHAVE_ALSA)
endif()


if(BUILD_WELLE_CLI AND NOT ANDROID)
    find_package(Lame REQUIRED)
    if (FLAC)
    find_package(FLACPP REQUIRED) # test if FLAC is installed on the system
    add_definitions(-DHAVE_FLAC)
    endif()
endif()

find_package(Threads REQUIRED)

if(NOT ANDROID)
    if(KISS_FFT)
        add_definitions(-DKISSFFT)
        set(fft_sources src/libs/kiss_fft/kiss_fft.c)
        set(KISS_INCLUDE_DIRS src/libs/kiss_fft)
    else()
        find_package(FFTW3f REQUIRED)
        set(fft_sources "")
        set(KISS_INCLUDE_DIRS "")
    endif()
    find_package(Faad REQUIRED)
    find_package(MPG123 REQUIRED)
else()
    # For KISSFFT
    add_definitions(-DKISSFFT)
    include_directories(
        src/libs/kiss_fft
    )
    set(fft_sources
        src/libs/kiss_fft/kiss_fft.c
    )

    # For MPG123
    add_definitions(-DOPT_GENERIC)
    include_directories(
        src/libs/mpg123
    )
    set(mpg123_sources
        src/libs/mpg123/compat.c
        src/libs/mpg123/compat_str.c
        src/libs/mpg123/parse.c
        src/libs/mpg123/frame.c
        src/libs/mpg123/format.c
        src/libs/mpg123/dct64.c
        src/libs/mpg123/equalizer.c
        src/libs/mpg123/id3.c
        src/libs/mpg123/icy.c
        src/libs/mpg123/icy2utf8.c
        src/libs/mpg123/optimize.c
        src/libs/mpg123/readers.c
        src/libs/mpg123/tabinit.c
        src/libs/mpg123/libmpg123.c
        src/libs/mpg123/index.c
        src/libs/mpg123/layer1.c
        src/libs/mpg123/layer2.c
        src/libs/mpg123/layer3.c
        src/libs/mpg123/dither.c
        src/libs/mpg123/feature.c
        src/libs/mpg123/synth.c
        src/libs/mpg123/synth_real.c
        src/libs/mpg123/ntom.c
        src/libs/mpg123/synth_8bit.c
        src/libs/mpg123/synth_s32.c
        src/libs/mpg123/stringbuf.c
    )

    # For FAAD
    add_definitions(-DHAVE_CONFIG_H)
    include_directories(
        src/libs/faad2
        src/libs/faad2/include
        src/libs/faad2/libfaad
        src/libs/faad2/libfaad/codebook
    )
    set(faad_sources
        src/libs/faad2/libfaad/bits.c
        src/libs/faad2/libfaad/cfft.c
        src/libs/faad2/libfaad/common.c
        src/libs/faad2/libfaad/decoder.c
        src/libs/faad2/libfaad/drc.c
        src/libs/faad2/libfaad/drm_dec.c
        src/libs/faad2/libfaad/error.c
        src/libs/faad2/libfaad/filtbank.c
        src/libs/faad2/libfaad/hcr.c
        src/libs/faad2/libfaad/huffman.c
        src/libs/faad2/libfaad/ic_predict.c
        src/libs/faad2/libfaad/is.c
        src/libs/faad2/libfaad/lt_predict.c
        src/libs/faad2/libfaad/mdct.c
        src/libs/faad2/libfaad/mp4.c
        src/libs/faad2/libfaad/ms.c
        src/libs/faad2/libfaad/output.c
        src/libs/faad2/libfaad/pns.c
        src/libs/faad2/libfaad/ps_dec.c
        src/libs/faad2/libfaad/ps_syntax.c
        src/libs/faad2/libfaad/pulse.c
        src/libs/faad2/libfaad/rvlc.c
        src/libs/faad2/libfaad/sbr_dct.c
        src/libs/faad2/libfaad/sbr_dec.c
        src/libs/faad2/libfaad/sbr_e_nf.c
        src/libs/faad2/libfaad/sbr_fbt.c
        src/libs/faad2/libfaad/sbr_hfadj.c
        src/libs/faad2/libfaad/sbr_hfgen.c
        src/libs/faad2/libfaad/sbr_huff.c
        src/libs/faad2/libfaad/sbr_qmf.c
        src/libs/faad2/libfaad/sbr_syntax.c
        src/libs/faad2/libfaad/sbr_tf_grid.c
        src/libs/faad2/libfaad/specrec.c
        src/libs/faad2/libfaad/ssr.c
        src/libs/faad2/libfaad/ssr_fb.c
        src/libs/faad2/libfaad/ssr_ipqf.c
        src/libs/faad2/libfaad/syntax.c
        src/libs/faad2/libfaad/tns.c
    )
endif()

if (RTLSDR)
    find_package(LibRTLSDR REQUIRED)
endif()

if (AIRSPY)
    find_package(LibAIRSPY REQUIRED)
endif()

if (SOAPYSDR)
  find_package(SoapySDR NO_MODULE REQUIRED)
  # Note: SoapySDRConfig.cmake sets C++11 standard so it needs to be reset to C++14
  set(CMAKE_CXX_STANDARD 14)
endif()

include_directories(
    ${CMAKE_CURRENT_BINARY_DIR}
    src
    src/backend
    src/output
    src/various
    src/input
    src/gui
    src/libs/fec
    ${FFTW3F_INCLUDE_DIRS}
    ${KISS_INCLUDE_DIRS}
    ${FAAD_INCLUDE_DIRS}
    ${LIBRTLSDR_INCLUDE_DIRS}
    ${SoapySDR_INCLUDE_DIRS}
    ${FLACPP_INCLUDE_DIRS}
)

set(backend_sources
    src/backend/dab-audio.cpp
    src/backend/decoder_adapter.cpp
    src/backend/dab_decoder.cpp
    src/backend/dabplus_decoder.cpp
    src/backend/charsets.cpp
    src/backend/dab-constants.cpp
    src/backend/mot_manager.cpp
    src/backend/pad_decoder.cpp
    src/backend/eep-protection.cpp
    src/backend/fib-processor.cpp
    src/backend/fic-handler.cpp
    src/backend/msc-handler.cpp
    src/backend/freq-interleaver.cpp
    src/backend/ofdm-decoder.cpp
    src/backend/ofdm-processor.cpp
    src/backend/phasereference.cpp
    src/backend/phasetable.cpp
    src/backend/tii-decoder.cpp
    src/backend/protTables.cpp
    src/backend/radio-receiver.cpp
    src/backend/tools.cpp
    src/backend/uep-protection.cpp
    src/backend/viterbi.cpp
    src/various/Socket.cpp
    src/various/Xtan2.cpp
    src/various/channels.cpp
    src/various/fft.cpp
    src/various/profiling.cpp
    src/various/wavfile.c
    src/libs/fec/decode_rs_char.c
    src/libs/fec/encode_rs_char.c
    src/libs/fec/init_rs_char.c
)

set(welle_io_sources
    src/welle-gui/main.cpp
    src/welle-gui/audio_output.cpp
    src/welle-gui/mot_image_provider.cpp
    src/welle-gui/gui_helper.cpp
    src/welle-gui/radio_controller.cpp
    src/welle-gui/debug_output.cpp
    src/welle-gui/waterfallitem.cpp
)

if(Qt6DBus_FOUND)
    list(APPEND welle_io_sources
        src/welle-gui/mpris/mpris.cpp
        src/welle-gui/mpris/mpris_mp2.cpp
        src/welle-gui/mpris/mpris_mp2_player.cpp
    )
endif()

if(ANDROID)
    include_directories(
        src/welle-gui
    )
    list(APPEND welle_io_sources
        src/welle-gui/android_rtl_sdr.cpp
    )
endif()

set(welle_cli_sources
    src/welle-cli/welle-cli.cpp
    src/welle-cli/alsa-output.cpp
    src/welle-cli/webradiointerface.cpp
    src/welle-cli/jsonconvert.cpp
    src/welle-cli/webprogrammehandler.cpp
    src/welle-cli/tests.cpp
)

set(input_sources
    src/input/input_factory.cpp
    src/input/null_device.cpp
    src/input/raw_file.cpp
    src/input/rtl_tcp.cpp
)

if(LIBRTLSDR_FOUND)
    add_definitions (-DHAVE_RTLSDR)
    set(input_sources  ${input_sources} src/input/rtl_sdr.cpp)
endif()

if(LIBAIRSPY_FOUND)
    add_definitions (-DHAVE_AIRSPY)
    set(input_sources  ${input_sources} src/input/airspy_sdr.cpp)
endif()

if(SoapySDR_FOUND)
    add_definitions (-DHAVE_SOAPYSDR)
    set(input_sources  ${input_sources} src/input/soapy_sdr.cpp)
endif()

if(NOT GIT_COMMIT_HASH)
  execute_process(
    COMMAND git rev-parse --short HEAD
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    OUTPUT_VARIABLE GIT_COMMIT_HASH
    OUTPUT_STRIP_TRAILING_WHITESPACE
  )
endif()

if(GIT_COMMIT_HASH)
  add_definitions("-DGITHASH=\"${GIT_COMMIT_HASH}\"")
endif()

if(NOT GIT_DESCRIBE)
  execute_process(
    COMMAND git describe --tags --long
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    OUTPUT_VARIABLE GIT_DESCRIBE
    OUTPUT_STRIP_TRAILING_WHITESPACE
  )
endif()

if(GIT_DESCRIBE)
  add_definitions("-DGITDESCRIBE=\"${GIT_DESCRIBE}\"")
endif()

add_definitions("-DCURRENT_VERSION=\"${CURRENT_VERSION}\"")

STRING(TIMESTAMP BUILD_DATE "%s" UTC)
add_definitions("-DBUILD_DATE=\"${BUILD_DATE}\"")

if(BUILD_WELLE_IO)
    set(executableName welle-io)

    if(CMAKE_AUTORCC)
        qt_add_executable (${executableName} MANUAL_FINALIZATION ${welle_io_sources} ${backend_sources} ${input_sources} ${fft_sources} ${mpg123_sources} ${faad_sources} ${EXTRA_MOCS} src/welle-gui/resources.qrc)
    else()
        qt_add_resources(welle_io_sources src/welle-gui/resources.qrc)
        qt_add_executable (${executableName} MANUAL_FINALIZATION ${welle_io_sources} ${backend_sources} ${input_sources} ${fft_sources} ${mpg123_sources} ${faad_sources} ${EXTRA_MOCS})
    endif()

    if(ANDROID)
        # Compute version code from CURRENT_VERSION value
        string(REGEX MATCH
          "^([0-9]+)\.([0-9]+)\.?([0-9]*)([^0-9]*)"
          CVC_MATCH
          "${CURRENT_VERSION}"
          )

        if(NOT CMAKE_MATCH_3 STREQUAL "")
          math(EXPR CURRENT_VERSION_CODE "${CMAKE_MATCH_1} * 100 + ${CMAKE_MATCH_2} * 10 + ${CMAKE_MATCH_3}")
        else()
          math(EXPR CURRENT_VERSION_CODE "${CMAKE_MATCH_1} * 100 + ${CMAKE_MATCH_2} * 10")
        endif()

        if(NOT CMAKE_MATCH_4 STREQUAL "")
          math(EXPR CURRENT_VERSION_CODE "${CURRENT_VERSION_CODE} - 1")
        endif()

        message (VERBOSE "CURRENT_VERSION_CODE: '${CURRENT_VERSION_CODE}'")

        if(CMAKE_AUTORCC)
            set_property(TARGET ${executableName} PROPERTY AUTORCC_OPTIONS "--no-zstd")
        endif()

        set_property(TARGET ${executableName} PROPERTY QT_ANDROID_PACKAGE_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/src/welle-gui/android)
        set_property(TARGET ${executableName} PROPERTY QT_ANDROID_VERSION_NAME ${CURRENT_VERSION})
        set_property(TARGET ${executableName} PROPERTY QT_ANDROID_VERSION_CODE ${CURRENT_VERSION_CODE})

        # Additional requirements when using Android
        target_link_libraries (${executableName} PRIVATE
            Qt6::CorePrivate
        )

        # Additional components to link to, because otherwise, the builder reports errors like this one:
        #   Skipping /usr/lib/qt-android-6.3-armeabi-v7a/plugins/platforminputcontexts/libplugins_platforminputcontexts_qtvirtualkeyboardplugin_armeabi-v7a.so. It has unmet dependencies: lib/libQt6VirtualKeyboard_armeabi-v7a.so.
        find_package(Qt6 COMPONENTS Svg REQUIRED)
        target_link_libraries (${executableName} PRIVATE
            Qt6::Svg
        )
        find_package(Qt6 COMPONENTS VirtualKeyboard)
        if(Qt6VirtualKeyboard_FOUND)

=== debian/changelog ===
welle.io (2.7+ds-1) unstable; urgency=medium

  * New upstream version.
  * Ack NMU.
  * Bump standards version to 4.7.2.
  * d/control:
    - drop Fab Stz from Uploaders. (Closes: #1068824)
    - drop Rules-Requires-Root.
    - Build-Depends/Depends update from qt5 to qt6.
  * d/copyright:
    - bump years.
    - update FSF address.
  * d/rules: add -DCMAKE_POLICY_VERSION_MINIMUM=3.5.
  * d/patches:
    - cmake-4.patch: dropped.
    - append-theme-path.patch: dropped.
    - cli-path-patch: dropped.

 -- Alex Myczko <tar@debian.org>  Fri, 05 Dec 2025 18:28:53 +0000

=== debian/control ===
Source: welle.io
Section: hamradio
Priority: optional
Maintainer: Debian Hamradio Maintainers <debian-hams@lists.debian.org>
Uploaders: Alex Myczko <tar@debian.org>
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 libairspy-dev,
 libasound2-dev,
 libfaad-dev,
 libfftw3-dev,
 libmp3lame-dev,
 libmpg123-dev,
 libpulse-dev,
 librtlsdr-dev,
 libsoapysdr-dev,
 qt6-base-dev,
 qt6-declarative-dev,
 qt6-multimedia-dev,
 qt6-charts-dev,
 qt6-multimedia-dev,
 qt6-base-dev-tools,
 xxd,
Standards-Version: 4.7.2
Vcs-Git: https://salsa.debian.org/debian-hamradio-team/welle.io.git
Vcs-Browser: https://salsa.debian.org/debian-hamradio-team/welle.io
Homepage: https://www.welle.io/

Package: welle.io
Architecture: any
Depends:
 qml6-module-qtquick-window,
 qml6-module-qtquick-templates,
 qml6-module-qtquick-controls,
 qml6-module-qt-labs-settings,
 qml6-module-qtcharts,
 qml6-module-qt5compat-graphicaleffects,
 qml6-module-qtquick-controls,
 qml6-module-qtquick-dialogs,
 qml6-module-qtquick-layouts,
 qml6-module-qtquick-localstorage,
 ${misc:Depends},
 ${shlibs:Depends}
Description: DAB/DAB+ Software Radio
 This is an open source DAB and DAB+ software defined radio (SDR) with support
 for rtl-sdr (RTL2832U) and airspy. It supports high DPI and touch displays and
 it runs even on cheap computers like Raspberry Pi 2/3 and 100€ China Windows
 10 tablets.

=== debian/rules ===
--- 
+++ 
@@ -3,8 +3,8 @@
 
 include /usr/share/dpkg/pkg-info.mk
 
-export QTDIR=/usr/share/qt5
-export QT_SELECT=qt5
+#export QTDIR=/usr/share/qt5
+#export QT_SELECT=qt5
 
 # see FEATURE AREAS in dpkg-buildflags(1)
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
@@ -19,4 +19,4 @@
 	dh $@
 
 override_dh_auto_configure:
-	dh_auto_configure -- -DRTLSDR=1 -DSOAPYSDR=1 -DAIRSPY=1 -DGIT_DESCRIBE=${DEB_VERSION_UPSTREAM}
+	dh_auto_configure -- -DRTLSDR=1 -DSOAPYSDR=1 -DAIRSPY=1 -DGIT_DESCRIBE=${DEB_VERSION_UPSTREAM} -DCMAKE_POLICY_VERSION_MINIMUM=3.5
